/*
 * Copyright (C) 2007-2010 Siemens AG
 *
 * This program and its interfaces are free software;
 * you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package com.siemens.ct.exi.grammar.rule;

import com.siemens.ct.exi.grammar.event.Event;

/**
 * TODO Description
 * 
 * @author Daniel.Peintner.EXT@siemens.com
 * @author Joerg.Heuer@siemens.com
 * 
 * @version 0.4.20081008
 */

public interface SchemaInformedRule extends Rule {
	
//	/*
//	 * 
//	 */
//	public void addRule(Event event, Rule rule);
//
//	public void addTerminalRule(Event event);
	

	public void addTerminalRule(Event event);
	
	
	/*
	 * first rule is different (namespace declaration, xsi:type and xsi:nil)
	 */
	public void setFirstElementRule();
	
//	public boolean isFirstElementRule();

	/*
	 * sets whether type is castable
	 */
	public void setTypeCastable(boolean hasNamedSubtypes);

	/*
	 * sets whether element is nillable
	 */
	public void setNillable(boolean nillable, SchemaInformedRule typeEmpty);

	
	/*
	 * get empty type
	 */
	public Rule getTypeEmpty();
	
	
	/*
	 * Label
	 */
	public void setLabel(String label);

	public String getLabel();

	/*
	 * clones schema-informed rule
	 */
	public SchemaInformedRule duplicate();

}
